# Record Class CAServerDatabaseConfiguration

java.lang.Object
java.lang.Record
com.io7m.cardant.server.api.CAServerDatabaseConfiguration

Record Components:
  `kind` - The underlying SQL database kind
  `ownerRoleName` - The name of the role that owns the database; used for database setup and migrations
  `ownerRolePassword` - The password of the role that owns the database
  `workerRolePassword` - The password of the worker role used for normal database operation
  `readerRolePassword` - The password of the role used for read-only database access
  `address` - The database address
  `port` - The database port
  `databaseName` - The database name
  `databaseLanguage` - The language used for database search indexes
  `create` - true if the database should be created
  `upgrade` - `true` if the database schema should be upgraded
  `minimumConnections` - The minimum number of database connections in the pool
  `maximumConnections` - The maximum number of database connections in the pool

public record CAServerDatabaseConfiguration(CAServerDatabaseKind kind, String ownerRoleName, String ownerRolePassword, String workerRolePassword, Optional<String> readerRolePassword, String address, int port, String databaseName, CADatabaseLanguage databaseLanguage, boolean create, boolean upgrade, int minimumConnections, int maximumConnections) extends Record
Configuration for the database.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CAServerDatabaseConfiguration(CAServerDatabaseKind kind, String ownerRoleName, String ownerRolePassword, String workerRolePassword, Optional<String> readerRolePassword, String address, int port, String databaseName, CADatabaseLanguage databaseLanguage, boolean create, boolean upgrade, int minimumConnections, int maximumConnections)`
  Configuration for the database.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `address()`
  Returns the value of the `address` record component.
  `boolean`
  `create()`
  Returns the value of the `create` record component.
  `CADatabaseLanguage`
  `databaseLanguage()`
  Returns the value of the `databaseLanguage` record component.
  `String`
  `databaseName()`
  Returns the value of the `databaseName` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `CAServerDatabaseKind`
  `kind()`
  Returns the value of the `kind` record component.
  `int`
  `maximumConnections()`
  Returns the value of the `maximumConnections` record component.
  `int`
  `minimumConnections()`
  Returns the value of the `minimumConnections` record component.
  `String`
  `ownerRoleName()`
  Returns the value of the `ownerRoleName` record component.
  `String`
  `ownerRolePassword()`
  Returns the value of the `ownerRolePassword` record component.
  `int`
  `port()`
  Returns the value of the `port` record component.
  `Optional<String>`
  `readerRolePassword()`
  Returns the value of the `readerRolePassword` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `boolean`
  `upgrade()`
  Returns the value of the `upgrade` record component.
  `String`
  `workerRolePassword()`
  Returns the value of the `workerRolePassword` record component.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CAServerDatabaseConfiguration

    public CAServerDatabaseConfiguration(CAServerDatabaseKind kind, String ownerRoleName, String ownerRolePassword, String workerRolePassword, Optional<String> readerRolePassword, String address, int port, String databaseName, CADatabaseLanguage databaseLanguage, boolean create, boolean upgrade, int minimumConnections, int maximumConnections)
    Configuration for the database.
    Parameters:
      `kind` - The underlying SQL database kind
      `ownerRoleName` - The name of the role that owns the database; used for database setup and migrations
      `ownerRolePassword` - The password of the role that owns the database
      `workerRolePassword` - The password of the worker role used for normal database operation
      `readerRolePassword` - The password of the role used for read-only database access
      `address` - The database address
      `port` - The database port
      `databaseName` - The database name
      `databaseLanguage` - The language used for database search indexes
      `create` - true if the database should be created
      `upgrade` - `true` if the database schema should be upgraded
      `minimumConnections` - The minimum number of database connections in the pool
      `maximumConnections` - The maximum number of database connections in the pool

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with the `compare` method from their corresponding wrapper classes.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### kind

    public CAServerDatabaseKind kind()
    Returns the value of the `kind` record component.
    Returns:
      the value of the `kind` record component

  - ### ownerRoleName

    public String ownerRoleName()
    Returns the value of the `ownerRoleName` record component.
    Returns:
      the value of the `ownerRoleName` record component

  - ### ownerRolePassword

    public String ownerRolePassword()
    Returns the value of the `ownerRolePassword` record component.
    Returns:
      the value of the `ownerRolePassword` record component

  - ### workerRolePassword

    public String workerRolePassword()
    Returns the value of the `workerRolePassword` record component.
    Returns:
      the value of the `workerRolePassword` record component

  - ### readerRolePassword

    public Optional<String> readerRolePassword()
    Returns the value of the `readerRolePassword` record component.
    Returns:
      the value of the `readerRolePassword` record component

  - ### address

    public String address()
    Returns the value of the `address` record component.
    Returns:
      the value of the `address` record component

  - ### port

    public int port()
    Returns the value of the `port` record component.
    Returns:
      the value of the `port` record component

  - ### databaseName

    public String databaseName()
    Returns the value of the `databaseName` record component.
    Returns:
      the value of the `databaseName` record component

  - ### databaseLanguage

    public CADatabaseLanguage databaseLanguage()
    Returns the value of the `databaseLanguage` record component.
    Returns:
      the value of the `databaseLanguage` record component

  - ### create

    public boolean create()
    Returns the value of the `create` record component.
    Returns:
      the value of the `create` record component

  - ### upgrade

    public boolean upgrade()
    Returns the value of the `upgrade` record component.
    Returns:
      the value of the `upgrade` record component

  - ### minimumConnections

    public int minimumConnections()
    Returns the value of the `minimumConnections` record component.
    Returns:
      the value of the `minimumConnections` record component

  - ### maximumConnections

    public int maximumConnections()
    Returns the value of the `maximumConnections` record component.
    Returns:
      the value of the `maximumConnections` record component